#version 150

// Basic
in vec3 position;
in vec3 normal;

// Positioning
uniform mat4 trans;
uniform mat4 view;
uniform mat4 proj;

// Lighting
uniform vec3 lightPos;
uniform vec3 lightInt;

// Pass to frag
out vec3 LightInt;

void main()
{
    vec3 tnorm = normalize( transpose(inverse(mat3(trans))) * normal);
    vec4 eyeCoords = trans * vec4(position, 1.0);
    vec3 s = normalize(vec3(vec4(lightPos, 1.0) - eyeCoords));
    
    LightInt = lightInt * max( dot( s, tnorm ), 0.0 );;
    LightInt = clamp(LightInt + vec3(0.3, 0.3, 0.3), 0, 1);
    
    gl_Position = proj * view * trans * vec4(position, 1.0);
}
